package com.zavoo.svg
{	
	import com.zavoo.svg.SvgMath;
	
	import flash.display.Graphics;
	
	public class SvgPath
	{	
		public var d:Array;
		
		public function SvgPath(pathData:String)
		{			
			d = createPathArray(splitPathElements(pathData))
		}
		
		public function splitPathElements(elements:String):Array
		{
			elements = elements.replace(/(M)/si,"$1,");
			
			elements = elements.replace(/([ACSLHVQT])/sig,",$1,");
		
			elements = elements.replace(/(Z)/si,",$1");
			
			elements = elements.replace(/-/sg,",-");
			
			elements = elements.replace(/\s+/sg,",");
			elements = elements.replace(/,{2,}/sg,",");
			
			
			return elements.split(',');
		}	
		
		public function createPathArray(elements:Array):Array
		{
			/* Based on a portion of modified code from PathToArray.as by Helen Triolo */
			var path:Array = new Array();
			
			var i:int;
			
			var cmd:String;
			var qc:Array;
			var firstP:Object;
			var lastP:Object;
			var lastC:Object;
			
			var pos:int = 0;
			
			var cnt:int = 0;
			
			do
			{
				cnt++;
				if (cnt == 18)
				{
					1 == 1;
				}
				cmd = elements[pos++];
				switch(cmd)
				{
					case "M":
						// moveTo point
						firstP = lastP = {x:Number(elements[pos]), y:Number(elements[pos+1])};
						path.push(['M', [firstP.x, firstP.y]]);
						pos += 2;
						if (pos < elements.length && !isNaN(Number(elements[pos]))) {  
							do {
								// if multiple points listed, add the rest as lineTo points
								lastP = {x:Number(elements[pos]), y:Number(elements[pos+1])};
								path.push(['L', [lastP.x, lastP.y]]);
								firstP = lastP;
								pos += 2;
							} while (pos < elements.length && !isNaN(Number(elements[pos])));
						}
						break;
						
					case "l" :
						do {
							lastP = {x:lastP.x+Number(elements[pos]), y:lastP.y+Number(elements[pos+1])};
							path.push(['L', [lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 2;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "L" :
						do {
							lastP = {x:Number(elements[pos]), y:Number(elements[pos+1])};
							path.push(['L', [lastP.x, lastP.y]]);					
							firstP = lastP;
							pos += 2;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "h" :
						do {
							lastP = {x:lastP.x+Number(elements[pos]), y:lastP.y};
							path.push(['L', [lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 1;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "H" :
						do {
							lastP = {x:Number(elements[pos]), y:lastP.y};
							path.push(['L', [lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 1;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "v" :
						do {
							lastP = {x:lastP.x, y:lastP.y+Number(elements[pos])};
							path.push(['L', [lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 1;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "V" :
						do {
							lastP = {x:lastP.x, y:Number(elements[pos])};
							path.push(['L', [lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 1;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
			
					case "q" :
						do {
							// control is relative to lastP, not lastC
							lastC = {x:lastP.x+Number(elements[pos]), y:lastP.y+Number(elements[pos+1])};
							lastP = {x:lastP.x+Number(elements[pos+2]), y:lastP.y+Number(elements[pos+3])};
							path.push(['C', [lastC.x, lastC.y, lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 4;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "Q" :
						do {
							lastC = {x:Number(elements[pos]), y:Number(elements[pos+1])};					
							lastP = {x:Number(elements[pos+2]), y:Number(elements[pos+3])};
							path.push(['C', [lastC.x, lastC.y, lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 4;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "t" :
						do {
							// control is relative to lastP, not lastC
							lastC = {x:lastP.x, y:lastP.y+Number(elements[pos])};
							lastP = {x:lastP.x, y:lastP.y+Number(elements[pos+1])};
							path.push(['C', [lastC.x, lastC.y, lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 2;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
						
					case "T" :
						do {
							lastC = {x:lastP.x, y:Number(elements[pos])};					
							lastP = {x:lastP.x, y:Number(elements[pos+1])};
							path.push(['C', [lastC.x, lastC.y, lastP.x, lastP.y]]);
							firstP = lastP;
							pos += 2;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;						
						
					case "c" :
						do {
							// don't save if c1.x=c1.y=c2.x=c2.y=0 
							if (!Number(elements[pos]) && !Number(elements[pos+1]) && !Number(elements[pos+2]) && !Number(elements[pos+3])) {
							} else {
								qc = SvgMath.cubicBezierToQuadratic({x:lastP.x, y:lastP.y},   
										{x:lastP.x+Number(elements[pos]), y:lastP.y+Number(elements[pos+1])},
										{x:lastP.x+Number(elements[pos+2]), y:lastP.y+Number(elements[pos+3])},
										{x:lastP.x+Number(elements[pos+4]), y:lastP.y+Number(elements[pos+5])});
								for (i=0; i<qc.length; i++) {
									path.push(['C', [qc[i].cx, qc[i].cy, qc[i].ax, qc[i].ay]]);
								}
								lastC = {x:lastP.x+Number(elements[pos+2]), y:lastP.y+Number(elements[pos+3])};
								lastP = {x:lastP.x+Number(elements[pos+4]), y:lastP.y+Number(elements[pos+5])};
								firstP = lastP;
							}
							pos += 6;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));							
						break;
			
					case "C" :
						do {
						// don't save if c1.x=c1.y=c2.x=c2.y=0 
							if (!Number(elements[pos]) && !Number(elements[pos+1]) && !Number(elements[pos+2]) && !Number(elements[pos+3])) {
							} else {
								qc = SvgMath.cubicBezierToQuadratic({x:firstP.x, y:firstP.y},   
										{x:Number(elements[pos]), y:Number(elements[pos+1])},
										{x:Number(elements[pos+2]), y:Number(elements[pos+3])},
										{x:Number(elements[pos+4]), y:Number(elements[pos+5])});
								for (i=0; i<qc.length; i++) {							
									path.push(['C', [qc[i].cx, qc[i].cy, qc[i].ax, qc[i].ay]]);
								}
		
		
								lastC = {x:Number(elements[pos+2]), y:Number(elements[pos+3])};
								lastP = {x:Number(elements[pos+4]), y:Number(elements[pos+5])};
								firstP = lastP;
							}
							pos += 6;
						} while (pos < elements.length && !isNaN(Number(elements[pos])));
						break;
					case "A" :
						/* TO DO: Add Support for elliptical arcs */		
						path.push(['L', [elements[pos+5], elements[pos+6]]]);		
						
						pos += 7;
						break;
					case "a" :
						/* TO DO: Add Support for elliptical arcs */		
						path.push(['L', [lastP.x + elements[pos+5], lastP.y + elements[pos+6]]]);								
						pos += 7;
						break;	
					case "s" :
						// don't save if c1.x=c1.y=c2.x=c2.y=0 
						if (!Number(elements[pos]) && !Number(elements[pos+1]) && !Number(elements[pos+2]) && !Number(elements[pos+3])) {
						} else {
							qc = SvgMath.cubicBezierToQuadratic({x:firstP.x, y:firstP.y},   
								{x:lastP.x + (lastP.x - lastC.x), y:lastP.y + (lastP.y - lastC.y)},
								{x:lastP.x+Number(elements[pos]), y:lastP.y+Number(elements[pos+1])},
								{x:lastP.x+Number(elements[pos+2]), y:lastP.y+Number(elements[pos+3])});
							for (i=0; i<qc.length; i++) {
								path.push(['C', [qc[i].cx, qc[i].cy, qc[i].ax, qc[i].ay]]);
							}
	
							lastC = {x:lastP.x+Number(elements[pos]), y:lastP.y+Number(elements[pos+1])};
							lastP = {x:lastP.x+Number(elements[pos+2]), y:lastP.y+Number(elements[pos+3])};
							firstP = lastP;
						}
						pos += 4;
						break;
						
					case "S" :
						// don't save if c1.x=c1.y=c2.x=c2.y=0 
						if (!Number(elements[pos]) && !Number(elements[pos+1]) && !Number(elements[pos+2]) && !Number(elements[pos+3])) {
						} else {
							qc = SvgMath.cubicBezierToQuadratic({x:firstP.x, y:firstP.y},   
								{x:lastP.x + (lastP.x - lastC.x), y:lastP.y + (lastP.y - lastC.y)},
								{x:Number(elements[pos]), y:Number(elements[pos+1])},
								{x:Number(elements[pos+2]), y:Number(elements[pos+3])});
							for (i=0; i<qc.length; i++) {
								path.push(['C', [qc[i].cx, qc[i].cy, qc[i].ax, qc[i].ay]]);
							}
	
							lastC = {x:Number(elements[pos]), y:Number(elements[pos+1])};
							lastP = {x:Number(elements[pos+2]), y:Number(elements[pos+3])};
							firstP = lastP;
						}
						pos += 4;
						break;
						
					case "z" :
					case "Z" :
						if (firstP.x != lastP.x || firstP.y != lastP.y) {
							path.push(['L', [firstP.x, firstP.y]]);
						}
						pos++;
						break;
				}
			} while(pos < elements.length);
			
			return path;
		}
		
		public function drawToGraphics(g:Graphics, scale:Number = 1, offsetX:Number = 0, offsetY:Number = 0):void	
		{
			for each(var line:Array in d)
			{
				switch(line[0])
				{
					case "M":
						g.moveTo(Number(line[1][0]) * scale + offsetX, Number(line[1][1]) * scale + offsetY);
						break;
					
					case "L":
						g.lineTo(Number(line[1][0]) * scale + offsetX, Number(line[1][1]) * scale + offsetY);
						break;
					
					case "C":
						g.curveTo(Number(line[1][0]) * scale + offsetX, Number(line[1][1]) * scale + offsetY, 
							Number(line[1][2]) * scale + offsetX, Number(line[1][3]) * scale + offsetY);
						break;
				}
			}
			
		}
	}
	
}