package rxg
{
	import flash.events.Event;
	import flash.events.IEventDispatcher;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	import mx.events.PropertyChangeEvent;
	import mx.graphics.IFill;
	import mx.graphics.IStroke;
	
	import reflex.events.RenderPhase;
	import reflex.metadata.resolveCommitProperties;
	
		
	public class GraphicElement extends ShapeDisplay
	{
		static public const DRAW:String = "draw";
		RenderPhase.registerPhase(DRAW, 0, true);
		
		public function GraphicElement()
		{
			reflex.metadata.resolveCommitProperties(this);
			addEventListener(DRAW, onDraw, false, 0, true);
		}
		
		private var _fill:IFill;
		public function get fill():IFill { return _fill; }
		public function set fill(value:IFill):void {
			_fill = value;
			(_fill as IEventDispatcher).addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, propertyChangeHandler);
		}
		
		private var _stroke:IStroke;
		public function get stroke():IStroke { return _stroke; }
		public function set stroke(value:IStroke):void {
			_stroke = value;
			(_stroke as IEventDispatcher).addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, propertyChangeHandler);
		}
		
		protected function propertyChangeHandler(event:PropertyChangeEvent):void {
			RenderPhase.invalidate(this, DRAW)
		}
		
		[CommitProperties(target="x, y, width, height, fill, stroke")]
		public function updateRender(event:Event):void {
			RenderPhase.invalidate(this, DRAW)
		}
		
		
		private function onDraw(event:Event = null):void {
			if(width > 0 && height > 0) {
				graphics.clear()
				var rectangle:Rectangle = new Rectangle(0, 0, width, height);
				if(stroke != null) { stroke.apply(graphics, rectangle, new Point()); }
				if(fill != null) { fill.begin(graphics, rectangle, new Point()); }
				draw()
				if(fill != null) { fill.end(graphics); }
			}
		}
		
		public function draw():void {
			graphics.drawRect(0, 0, width, height);
		}
		
		
	}
}