package rxg
{
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	import reflex.events.PropertyEvent;
	import reflex.events.RenderPhase;
	
	public class Rect extends GraphicElement
	{
		private var _radiusX:Number = 0;
		private var _radiusY:Number;
		
		[Bindable(event="radiusXChange")]
		public function get radiusX():Number { return _radiusX; }
		public function set radiusX(value:Number):void {
			if (_radiusX == value) {
				return;
			}
			PropertyEvent.dispatchChange(this, "radiusX", _radiusX, _radiusX = value);
			RenderPhase.invalidate(this, DRAW)
		}
		
		[Bindable(event="radiusYChange")]
		public function get radiusY():Number { return _radiusY; }
		public function set radiusY(value:Number):void {
			if (_radiusY == value) {
				return;
			}
			PropertyEvent.dispatchChange(this, "radiusY", _radiusY, _radiusY = value);
			RenderPhase.invalidate(this, DRAW)
		}
		
		override public function draw():void {
			//http://opensource.adobe.com/wiki/display/flexsdk/FXG+2.0+Specification#FXG2.0Specification-TheRectelement				
			graphics.drawRoundRect(0, 0, width, height, radiusX, isNaN(radiusY) ? radiusX : radiusY);
		}
	}
}