package rxl
{	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.Dictionary;
	
	import reflex.layouts.ILayout;
	import reflex.layouts.Layout;
	import reflex.measurement.*;

	
	/**
	 * Middle-centered flow layout
	**/
	public class FlowLayout extends Layout implements ILayout
	{
		[Bindable] public var hGap:Number = 5;
		[Bindable] public var vGap:Number = 5;
						
		override public function update(children:Array, rectangle:Rectangle):void
		{							
			super.update(children, rectangle)
				
			var point:Point = this.measure(children)
				
			var pX:Number = 0
			var pY:Number = 0
			var maxHeight:Number = 0
				
			var rowsLength:Array = new Array() 
				
			for each (var child:Object in children)
			{
				var width:Number = reflex.measurement.resolveWidth(child)
				var height:Number = reflex.measurement.resolveHeight(child)
				
				if (pX + width + hGap  > rectangle.width)
				{
					rowsLength.push(pX)
					pX = 0					
					pY += maxHeight + vGap
					maxHeight = 0
				}
				
				child.x = pX
				child.y = pY
								
				pX += width + hGap
				maxHeight = Math.max(height, maxHeight)
			}
			
			//centering			
			pY += maxHeight			
			var deltaY:Number = (rectangle.height - pY)/2
			deltaY = Math.max(deltaY, 0)
			rowsLength.push(pX)
			pX = 0
			var rowNumber:Number = 0
			for each (child in children)
			{
				width = reflex.measurement.resolveWidth(child)
				height = reflex.measurement.resolveHeight(child)
				
				if (pX + width + hGap  > rectangle.width)
				{
					rowNumber++
					pX = 0
				}
				
				pX += width + hGap
				
				var deltaX:Number = (rectangle.width - rowsLength[rowNumber])/2
				deltaX = Math.max(deltaX, 0)
					
				child.y += deltaY
				child.x += deltaX
			}
		}
	}
}